package com.gprinter.zb;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.net.URL;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.jar.JarFile;

/* loaded from: com_gprinter_zb.jar:com/gprinter/zb/ReflectionUtil.class */
class ReflectionUtil {
    static final /* synthetic */ boolean $assertionsDisabled;

    static {
        $assertionsDisabled = !ReflectionUtil.class.desiredAssertionStatus();
    }

    public static Set<Class<?>> getClassesInPackage(String var0) throws ClassNotFoundException, IOException {
        return new HashSet(Arrays.asList(getClasses(var0)));
    }

    public static Set<Class<?>> getClassesInPackageExtending(String var0, Class<?> var1) throws ClassNotFoundException, IOException {
        Set var2 = getClassesInPackage(var0);
        Iterator var3 = var2.iterator();
        while (var3.hasNext()) {
            Class<?> var4 = var3.next();
            if (Modifier.isAbstract(var4.getModifiers()) || !var1.isAssignableFrom(var4)) {
                var3.remove();
            }
        }
        return var2;
    }

    private static Class<?>[] getClasses(String var0) throws ClassNotFoundException, IOException {
        ClassLoader var1 = Thread.currentThread().getContextClassLoader();
        if (!$assertionsDisabled && var1 == null) {
            throw new AssertionError();
        }
        String var2 = var0.replace('.', '/');
        URL var3 = var1.getResource(var2);
        ArrayList var4 = new ArrayList();
        if (var3.getProtocol().equals("jar")) {
            String var5 = URLDecoder.decode(var3.getFile(), "UTF-8");
            JarFile var6 = new JarFile(var5.substring(5, var5.indexOf("!")));
            Enumeration var7 = var6.entries();
            while (var7.hasMoreElements()) {
                String var8 = var7.nextElement().getName();
                if (var8.startsWith(var2) && var8.length() > var2.length() + 5 && var8.endsWith(".class")) {
                    String var9 = var8.replace('/', '.');
                    var4.add(Class.forName(var9.substring(0, var9.length() - 6)));
                }
            }
            var6.close();
        } else {
            Enumeration var10 = var1.getResources(var2);
            ArrayList var11 = new ArrayList();
            while (var10.hasMoreElements()) {
                URL var12 = var10.nextElement();
                var11.add(new File(var12.getFile()));
            }
            Iterator var13 = var11.iterator();
            while (var13.hasNext()) {
                File var14 = (File) var13.next();
                var4.addAll(findClasses(var14, var0));
            }
        }
        return (Class[]) var4.toArray(new Class[var4.size()]);
    }

    private static List<Class<?>> findClasses(File var0, String var1) throws ClassNotFoundException {
        ArrayList var2 = new ArrayList();
        if (!var0.exists()) {
            return var2;
        }
        File[] var3 = var0.listFiles();
        for (File var7 : var3) {
            if (var7.isDirectory()) {
                if (!$assertionsDisabled && var7.getName().contains(".")) {
                    throw new AssertionError();
                }
                var2.addAll(findClasses(var7, var1 + "." + var7.getName()));
            } else if (var7.getName().endsWith(".class")) {
                var2.add(Class.forName(var1 + '.' + var7.getName().substring(0, var7.getName().length() - 6)));
            }
        }
        return var2;
    }

    public static ZebraImageI invokeZebraImageFactory_getImage(String var0) throws IOException {
        ClassLoader var1 = Thread.currentThread().getContextClassLoader();
        try {
            Class var2 = var1.loadClass("com.zebra.sdk.graphics.ZebraImageFactory");
            Method var3 = var2.getMethod("getImage", String.class);
            Object var4 = var3.invoke(null, var0);
            return (ZebraImageI) var4;
        } catch (Exception var5) {
            throw new IOException(var5.getCause().getLocalizedMessage());
        }
    }

    public static ZebraImageI invokeZebraImageFactory_getImage(InputStream var0) throws IOException {
        ClassLoader var1 = Thread.currentThread().getContextClassLoader();
        try {
            Class var2 = var1.loadClass("com.zebra.sdk.graphics.ZebraImageFactory");
            Method var3 = var2.getMethod("getImage", InputStream.class);
            Object var4 = var3.invoke(null, var0);
            return (ZebraImageI) var4;
        } catch (Exception var5) {
            throw new IOException(var5.getCause().getLocalizedMessage());
        }
    }
}
